--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: HDMI_ADV7511_Interface.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::PolarFire> <Die::MPF300T_ES> <Package::FCG1152>
-- Author: <Name>
--
--------------------------------------------------------------------------------

library IEEE;

use IEEE.std_logic_1164.all;

entity HDMI_ADV7511_Interface is
port (
	clk               : in  std_logic;
    nReset            : in  std_logic;
    int               : in  std_logic;
    ADV7511_D_OUT     : out std_logic_vector(23 downto 0);
    ADV7511_TX_CLK    : out std_logic;
    ADV7511_TX_DE     : out std_logic;
    ADV7511_TX_HSYNC  : out std_logic;
    ADV7511_TX_VSYNC  : out std_logic;
    ADV7511_CEC_CLK   : out std_logic;
    ADV7511_TX_S_PDIF : out std_logic;
    ADV7511_TX_MCLK   : out std_logic;
    ADV7511_TX_I2S    : out std_logic_vector(3 downto 0);
    ADV7511_TX_SCLK   : out std_logic;
    ADV7511_TX_LRCK   : out std_logic
);
end HDMI_ADV7511_Interface;
architecture architecture_HDMI_ADV7511_Interface of HDMI_ADV7511_Interface is

    signal d_out_i : std_logic_vector(35 downto 0);
    signal pb_i    : std_logic_vector(5 downto 0) := (others => '0');

    component top_sync_vg_pattern
        port (
            clk_in      : in  std_logic;
            resetb      : in  std_logic;
            pb          : in  std_logic_vector(5 downto 0);
            adv7511_hs  : out std_logic;
            adv7511_vs  : out std_logic;
            adv7511_clk : out std_logic;
            adv7511_d   : out std_logic_vector(35 downto 0);
            adv7511_de  : out std_logic
        );
    end component;

begin

    pattern_gen : top_sync_vg_pattern
        port map (
            clk_in      => clk,
            resetb      => nReset,
            pb          => pb_i,
            adv7511_hs  => ADV7511_TX_HSYNC,
            adv7511_vs  => ADV7511_TX_VSYNC,
            adv7511_clk => ADV7511_TX_CLK,
            adv7511_d   => d_out_i,
            adv7511_de  => ADV7511_TX_DE
        );
        

    ADV7511_d_out(7  downto 0)  <= d_out_i(11  downto 4);
    ADV7511_d_out(15 downto 8)  <= d_out_i(23 downto 16);
    ADV7511_d_out(23 downto 16) <= d_out_i(35 downto 28);

end architecture_HDMI_ADV7511_Interface;
